function StObject(){};
function StBehavior(){};
function StClass(){};
function StMetaclass(){ this.$meta = true; };
function StMethod(){};

function StUndefinedObject(){};
var nil = new StUndefinedObject();
nil.toString = function() { return 'nil'; };

function StSystemDictionary(){
	var st = this;
	st.$imageFileName = "s8.image.js";
	st.isNil = function(aValue) { return (aValue || nil) === nil; }

	st.klass = function(spec) { // Private
		var aClass;
		if(spec.meta) {
			aClass = new StMetaclass();
		} else {
			var metaSpec = {meta:true};
			metaSpec.className = spec.className + " class";
			if (!st.isNil(spec.superclass)) {
				metaSpec.superclass = spec.superclass.$klass;
			}
			var metaClass = st.klass(metaSpec);
			aClass = new metaClass.$fn();
		}
		st.setClass(aClass,spec);
		aClass.$fn.prototype.$klass = aClass;
		aClass.$fn.prototype.$methods = {};
		if (aClass.$className == "Metaclass") { st.bindRoots(aClass); }
		return aClass;
	}
	st.setProtoOf_to_ = function(jsObject, proto) { // change (dynamically) th eprototype of jsObject to proto
		jsObject.__proto__ = proto;
	}
	st.bindRoots = function(metaclass){ // Private
		var objectClassPrototype = st.Object.$klass.$fn.prototype;
		st.setProtoOf_to_(objectClassPrototype,st.Class.$fn.prototype);
		st.setProtoOf_to_(st.Smalltalk.$klass.$fn.prototype,objectClassPrototype);
		st.setProtoOf_to_(st.Behavior.$klass.$fn.prototype,objectClassPrototype);
		st.Object.$klass.$superclass = st.Class;
		metaclass.$superclass = st.Behavior;
	}
	st.setVarNames = function(aClass, iVarNames, aValue) { // Private
		aClass.$iVarNames = iVarNames;
		var i=iVarNames.length;while(i--){
			aClass.$fn.prototype["@"+iVarNames[i]] = aValue;
		}
	}
	st.setClass = function(aClass, spec) { // Private
		aClass.$className = spec.className;
		if(!spec.meta) { aClass.$klass["@instanceClass"] = aClass; }
		aClass.$category = spec.category || "";
		aClass.$superclass = spec.superclass || nil;
		if(!st.isNil(aClass.$superclass)) {
			delete aClass.$superclass["@subclasses"];
			if(!st.isNil(aClass.$klass)) {
				if(!spec.meta) aClass.$klass.$superclass = aClass.$superclass.$klass;
				if(aClass.$klass.$superclass)
					delete aClass.$klass.$superclass["@subclasses"];
			}
		}
		aClass.$fn = st.fnInSpec(spec);
		st.setVarNames(aClass,spec.iVarNames||[],nil);
		return aClass;
	}
	st.fnInSpec = function(spec) { // Private
		if (spec.meta && (st.isNil(spec.superclass))) {
			spec.superclass = st.Class;
		}
		if (spec.fn) {
			if (!st.isNil(spec.superclass))
				st.setProtoOf_to_(spec.fn.prototype,spec.superclass.$fn.prototype);
			return spec.fn;
		}
		var result = function(){};
		if (!st.isNil(spec.superclass))
			result.prototype = new spec.superclass.$fn();
		return result;
	}

	st.initClass = function(aClass) { // Private, DEPRECATED
		return "DEPRECATED";
	}

	st.initWithSubclasses = function(aClass) { // Private, DEPRECATED
		st.initClass(aClass);
		st.allSubclassesDo(aClass,st.initClass);
		return aClass;
	}
	st.init = function(aClass) { // DEPRECATED
		if(true) return "DEPRECATED";
		st.initWithSubclasses(aClass);
	}
	st.initRoots = function(){ // DEPRECATED
		if(true) return "DEPRECATED";
		var classes = st.classes();
		var i=classes.length;while(i--){
			if(st.isNil(classes[i].$superclass)) {
				st.initWithSubclasses(classes[i]);
			}
		}
		return classes;
	}

	st.classes = function() { // Return all the classes
		var classes = [];
		for (var i in st){ if (st.hasOwnProperty(i) && (i != "$klass")) {
		    var cls = st[i]; if(!st.isNil(cls)){
			if(cls.$klass && cls.$className){ classes.push(cls); }
		    } }
		}
		return classes;
	}

	st.subclasses = function(aClass) { // Return the subclasses of aClass
		if(aClass.hasOwnProperty("@subclasses")) return aClass["@subclasses"];
		var result = [];
		var classes = st.classes();
		var i=classes.length;while(i--){
		    if(classes[i].$fn) {
			if(classes[i].$klass
				&& classes[i].$klass.$superclass === aClass)
				{ result.push(classes[i].$klass); }
			if(classes[i].$superclass === aClass)
				{ result.push(classes[i]); }
		    }
		}
		if(st.Class){ // Class linked to Object.$klass
			if(aClass === st.Class) { var k;
				for(var i in result) {
					if(result[i] === st.Object.$klass) { k = i; }
				}
				if(k) result.splice(k,1);
			}
		}
		aClass["@subclasses"] = result;
		return result;
	}

	st.allSubclasses = function(aClass) { // OBSOLETE - will be removed soon.
		if(true) return "DEPRECATED";
		var subclasses = st.subclasses(aClass);
		var result = subclasses;
		for(var i=0;i<subclasses.length;i++) {
			result = result.concat(st.allSubclasses(subclasses[i]));
		}
		return result;
	}

	st.allSubclassesDo = function(aClass,aBlock) {
		var subclasses = st.subclasses(aClass);
		var i=subclasses.length;while(i--){
			var cls = subclasses[i];
			aBlock(cls);
			st.allSubclassesDo(cls,aBlock);
		}
		return st;
	}

	st.mapClassName = function(className, category, fn, superclass) {
		var spec = {
			className: className, 
			category: category, 
			superclass: superclass,
			fn: fn };
		if (st[className]) return st.setClass(st[className],spec);
		st[className] = st.klass(spec);
		return st[className];
	}

	st.addClass = function(className, superclass, iVarNames, category) {
		st.debugAddClass(className, superclass, iVarNames, category);
		if(st[className]) {
			var aClass = st[className];
			var sameShape = (aClass.$superclass == superclass)
				&& (aClass.$iVarNames == iVarNames);
			if (sameShape && (aClass.$category == category) ) return aClass;
			st.aboutToChangeClass(aClass,superclass,iVarNames,category);
			if(aClass.$superclass) {
				delete aClass.$superclass["@subclasses"];
				var aMeta = aClass.$klass;
				if (aMeta && superclass) {
					delete  aMeta.$superclass["@subclasses"];
					aMeta.$superclass = superclass.$klass;
				}
			}
			aClass.$superclass = superclass;
			if(superclass && (superclass["@subclasses"])) {
				if(st.isNil(superclass["@subclasses"])) { superclass["@subclasses"] = []; }
				superclass["@subclasses"].push(aClass); 
			}
			st.setVarNames(aClass,iVarNames||[],nil);
			aClass.$category = category || aClass.$category;
			if (!sameShape) st.classShapeChanged(aClass);
		} else {
			st.aboutToCreateClass(className,superclass,iVarNames,category);
			st[className] = st.klass({
				className: className, 
				iVarNames: iVarNames,
				superclass: superclass
			});
			st[className].$category = category || "";
		}
		st.classChanged(st[className]);
		return st[className];
	}
	st.renameClass = function(aClass,aString) {
		delete smalltalk[aClass.$className];
		aClass.$className = aString;
		smalltalk[aString] = aClass;
		st.classChanged(aClass);
	}
	st.removeClass = function(aClass) {
		var deleted = "Deleted-";
		if(aClass.$superclass) { delete aClass.$superclass["@subclasses"]; }
		delete smalltalk[aClass.$className];
		aClass.$className = deleted + aClass.$className;
		aClass.$klass.$className = deleted + aClass.$klass.$className;
		st.classChanged(aClass);
	}
	st.metaVarNames = function(aMetaClass,iVarNames) {
		if (aMetaClass.$iVarNames == iVarNames) return false;
		st.setVarNames(aMetaClass,iVarNames||[],nil);
		st.classShapeChanged(aMetaClass);
		st.classChanged(aMetaClass);
		return true;
	}

	st.smDo = function(block) {
		if (!st.SystemManager) return nil;
		if (!st.SystemManager.classVariableAt_) return nil;
		if (!st.SystemManager.currentOrNil) return nil;
		var sm = st.SystemManager.currentOrNil();
		if (!st.isNil(sm)) return block(sm);
	}
	st.classChanged = function(aBehavior) {
		st.smDo(function(sm){sm.classChanged_(aBehavior)});
	}
	st.classShapeChanged = function(aBehavior) {
		st.smDo(function(sm){sm.classShapeChanged_(aBehavior)});
	}
	st.aboutToCreateClass = function(className,superclass,iVarNames,category) {
		st.smDo(function(sm){sm.aboutToCreateClass_superclass_iVarNames_category_(className,superclass,iVarNames,category)});
	}
	st.aboutToChangeClass = function(aClass,superclass,iVarNames,category) {
		st.smDo(function(sm){sm.aboutToChange_superclass_iVarNames_category_(aClass,superclass,iVarNames,category)});
	}
	st.methodBoundTo = function(method,klass) {
		st.smDo(function(sm){sm.methodBound_to_(method,klass)})
		return method;
	}
	st.aboutToBindTo = function(method,klass) {
		st.smDo(function(sm){sm.aboutToBind_to_(method,klass)})
		return method;
	}
	st.aboutToRemoveFrom = function(method,klass) {
		st.smDo(function(sm){sm.aboutToRemove_from_(method,klass)})
		return method;
	}
	st.methodRemovedFrom = function(method,klass) {
		st.smDo(function(sm){sm.methodRemoved_from_(method,klass)})
		return method;
	}

	st.whoImplements = function(klass,jsSelector) { // Return the implementor of a jsSelector
		var cls = klass;
		do {	if(cls.$fn.prototype.hasOwnProperty(jsSelector)) return cls;
			cls = cls.$superclass;
		} while (cls);
		return nil;
	}

	st.addMethod = function(jsSelector, method, klass) {
		st.aboutToBindTo(method,klass);
		klass.$fn.prototype[jsSelector] = method.$fn;
		klass.$fn.prototype.$methods[method.$selector] = method;
		method["@classField"] = klass;
		return st.methodBoundTo(method,klass);
	}

	st.bind = function(klass,stSelector,jsSelector,jsFunction,category,stSource) {
		st.debugBind(klass,stSelector,jsSelector,jsFunction,category,stSource);
		var method = new StMethod();
		method.$selector = stSelector;
		method.$fn	= jsFunction;
		method.$category = category;
		method.$source = stSource;
		if(!st.isNil(klass)) {
			if(st.isNil(jsSelector)) { jsSelector = stSelector.replace(/\:/g,"_"); }
			st.addMethod(jsSelector,method,klass);
		}
		return method;
	}

	st.removeMethod = function(aClass,aMethod) {
		st.aboutToRemoveFrom(aMethod,aClass);
		delete aClass.$fn.prototype[aMethod.$selector.asSelector()];
		delete aClass.$fn.prototype.$methods[aMethod.$selector]
		return st.methodRemovedFrom(aMethod,aClass);
	}

	st.newMethod = function(currentClass,selector,fn,source) {
		return st.bind(nil,selector,nil,fn,nil,source);
	}
	st.method = function(spec) { // OBSOLETE - Return a new method from spec literal
		return st.bind(nil,spec.selector,nil,spec.fn,spec.category,spec.source);
	}

	st.readJSObject = function(js) { // Return a Smalltalk Object from javascript literal(js).
		if(!js) return nil;
		var object = js;
		var readObject = (js.constructor === Object);
		var readArray = (js.constructor === Array);
		if(readObject) { object = st.Dictionary.$$new(); }
		for(var i in js) {
			if (!js.hasOwnProperty(i)) break;
			if(readObject) { object.at_put_(i, st.readJSObject(js[i])); } 
			if(readArray) { object[i] = st.readJSObject(js[i]); }
		}
		return object;
	}

	st.globalsDo = function(action) { // Evaluate an action on each global key
		for (key in smalltalk) {
			if (!smalltalk.hasOwnProperty(key)) break;
			var aValue = st[key];
			if((typeof(aValue) != "function")
			 && (aValue.isClass
			 && (!aValue.isClass()))) { action(key) } }
		return st;
	}

	st.launchImage = function(imageName) { // Load an image from file, initialize and launch the system
		if(!st.isNil(imageName)) {
			st.$imageFileName = imageName;
			load(imageName);
		}
		//OBSOLETE - st.initRoots();
		if(st.launch && typeof st.launch == "function") { st.launch(); }
		return st;
	}

	st.debugBind = function(klass,stSelector,jsSelector,jsFunction,category,stSource) { return st; }
	st.debugAddClass = function(className, superclass, iVarNames, category) { return st; }
} // Smalltalk definition

var smalltalk = new StSystemDictionary();
smalltalk.toString = function() { return "smalltalk"; }
smalltalk.OverwriteMethods = smalltalk.OverwriteMethods || nil;
smalltalk.DumpOverwritenMethods = smalltalk.DumpOverwritenMethods || nil;

smalltalk.mapClassName("Object", "Kernel", StObject);
smalltalk.mapClassName("Smalltalk", "Kernel", StSystemDictionary, smalltalk.Object);
smalltalk.mapClassName("Behavior", "Kernel", StBehavior, smalltalk.Object);
smalltalk.mapClassName("Class", "Kernel", StClass, smalltalk.Behavior);
smalltalk.mapClassName("Metaclass", "Kernel", StMetaclass, smalltalk.Behavior);
smalltalk.mapClassName("CompiledMethod", "Kernel", StMethod, smalltalk.Object);

smalltalk.mapClassName("Number", "Kernel", Number, smalltalk.Object);
smalltalk.mapClassName("BlockClosure", "Kernel", Function, smalltalk.Object);
smalltalk.mapClassName("Boolean", "Kernel", Boolean, smalltalk.Object);
smalltalk.mapClassName("DateTime", "Kernel", Date, smalltalk.Object);
smalltalk.mapClassName("UndefinedObject", "Kernel", StUndefinedObject, smalltalk.Object);

smalltalk.mapClassName("Collection", "Kernel", undefined, smalltalk.Object);
smalltalk.mapClassName("SequenceableCollection", "Kernel", undefined, smalltalk.Collection);
smalltalk.mapClassName("String", "Kernel", String, smalltalk.SequenceableCollection);
smalltalk.mapClassName("Array", "Kernel", Array, smalltalk.SequenceableCollection);
smalltalk.mapClassName("RegularExpression", "Kernel", RegExp, smalltalk.Object);

//OBSOLETE - smalltalk.initRoots();